<?php
defined('BASEPATH') or die('error in test module');

class saman extends Payment_Module 
{
		 public		$name	= 'بانک سامان'; 	
		 
		 private $pin = 10054088;
		 private $pass = 1146933;
		
			/**
		*	construct method
		**/
		function __construct()
		{
			parent::__construct();
			@session_start();
			// if need nusoap class delete comment
			$this->load->helper('nusoap');
		}
		
		
			/**
		* 	method send request to bank and get authority!
		*
		* @param $price int , toman تومان
		* @param $order_id int , unique id
		* @param $callback string , callback site
		* @return object , au: authority , go: bank link payment , status: the status of connection!
		**/
		public function request($price = NULL , $order_id = NULL , $callback = NULL)
		{
			$out = new stdclass;
			$out->au = 'order-'.$order_id;
			$out->go = "";
			$out->status = true;
			
			$_ = array();
			$_['Amount'] = $price*10;
			$_['ResNum'] = $order_id;
			$_['RedirectURL']=$callback;
			$_SESSION[$out->au] = $_ ;
			
			
			return $out;
		}
		
		
			/**
		* method to check verify transaction
		*
		* @param $price int , تومان
		* @param $order_id int , unique order id 
		* @param $au string , authority code
		* @return bool true/false 
		**/
		public function verify($price = NULL ,$order_id = NULL , $au = NULL)
		{
			$ResNum	= @$_POST['ResNum'];
			
			if($ResNum != $order_id)
				return false;
				
			$RefNum	= @$_POST['RefNum'];
			$State	= @$_POST['State'];
			//$this->SaleReferenceId = $RefNum;
			if($State!='OK')
				return false;

			try
			{
				$soapclient = new nusoap_client('https://acquirer.samanepay.com/payments/referencepayment.asmx?WSDL','wsdl');
				$soapProxy	= $soapclient->getProxy() ;
				$amount		= $soapProxy->VerifyTransaction($RefNum,$this->pin);}
			catch(Exception $e)
			{
				_show_error('بانک سامان','خطا در برگشت عدم توانایی ارتباط با بانک سامان برای تراکنش {$order_id}');
				return false;
			}
			if($amount<0)
				_show_error('پرداخت ناموفق کد خطا'.$amount);
				
			if($amount != ($price*10))
			{
				_show_error('عدم تطابق مبلغ ارسالی و پرداختی در تراکنش شماره {$order_id} . مبلغ برگشت داده شد');
				$soapProxy->ReverseTransaction($RefNum,$this->pin,$this->pass,$amount);
				return false;
			}
			
			return $amount == ($price*10) ;		
		}
		
		
		
		function go($id)
		{
			//die($id);
			$_ = $_SESSION[$id];
			extract($_);
			 ?>
<!DOCTYPE html>
<html>
  <head>
   <meta charset='utf-8' />
  </head>
  <body>
  <meta charset='utf-8' />
  <center dir=rtl style='font-family:tahoma;font-size:11px'>
لطفا صبر کنید ... <br>

</center>
<form name='myform' action='https://acquirer.samanepay.com/Payment.aspx' method='POST'>
		<input type='hidden' id='Amount' name='Amount' value='<?php echo $Amount  ?>'>
		<input type='hidden' id='MID' name='MID' value='<?php echo $this->pin  ?>'>
		<input type='hidden' id='ResNum' name='ResNum' value='<?php echo $ResNum  ?>'>
		<input type='hidden' id='RedirectURL' name='RedirectURL' value='<?php echo $RedirectURL  ?>'>
	</form>
<script language='javascript'>document.myform.submit()</script>

  </body>
</html>
			 <?php
			 die;
		}
}

// Location : application/payment_modules/test.php
